<?
/****************************************************************************
S7_FUNCTION
 + ist eine Funktionssammlung um fr den Zugriff auf S7-Instanzen

Release: 0.3T --> TESTVERSION !!!!!!
ReleaseDate: 31.07.2009

ReleaseNote:
30.04.2009 - R0.3 - Gusenbauer
 + Function S7_VAR_IDs_READ geandert


31.07.2009 - R0.3T - Gusenbauer
 + Debugmeldungen wegen Test von IPS2.1b

ACHTUNG:

NUR ALS TESTVERSION GEDACHT 31.07.2009


LOGFILE WIRD AUF IPS-DIR geschrieben ==> z.b. 20090731.log









*****************************************************************************/

include_once ('./common_function.php');



function LOGFILE($LOGTEXT)
{
   list($usec, $sec) = explode(' ',microtime());
   $MILLISEC = str_pad(substr(((float)$usec),2,3),3,"0",STR_PAD_LEFT);
   $_logfilename =   IPS_GetKernelDir()  . date("Ymd"). ".LOG";
   $_logfp = fopen($_logfilename,"a");
   $_logtext =  "\r\n" . date("d.m.Y H:i:s") .":" . $MILLISEC . " | " . $LOGTEXT;
   fwrite($_logfp,$_logtext);
   fclose($_logfp);
}




/****************************************************************************
S7_VAR_IDs_READ,
  liest das uebergebene Variablenarray "S7_VAR_IDs" von der "S7_Instanz_ID"
  und legt die Variablen entsprechend dem "S7_Path" ab

Example:    //index0   = VARIABLENBEZEICHNUNG in IPS
            //index1.0 = TYP          (0=bit, 1=byte, 2=word, 3=dword,
				//                         4=ShortInt, 5=SmallInt, 6=Integer, 7=Real)
            //index1.1 = AREA         (0=SystemInfo, 1=SystemFlags,
				//                         2=AnalogInput CPU200, 3=AnalogOutput CPU200,
				//                         4=Input, 5=Output, 6=Flags, 7=Datablock,
				//                         8=InstanzDaten, 9=LokaleDaten, 10=UnknownedArea
				//                         11=Zaehler, 12=Timer, 13=PEW/PAW)
            //index1.2 = AREAADDRESS  (Baustein)
            //index1.3 = ADDRES       (StartByte)
            //index1.4 = BIT          (Bit = wird nur bei TYP=0 verarbeitet)
            //index1.5 = CONVERT-S7-Value vor schreiben auf die IPS-Variable
            //                        (0=unverndert, 1=Dec2Hex, 2=Hex2Dec)

            $S7_VAR_IDs = array("M0.1"   => array(0,6,0,0,1,0),
				                    "E41.1"  => array(0,4,0,41,1,0));
            S7_VAR_IDs_READ(123456,"S7/TEST",$S7_VAR_IDs);

ReleaseNotes:
02.04.2009 Gusenbauer
 + Function erstellt und geprft
07.04.2009 Gusenbauer
 + Wenn Lesefehler oder Zuweisungsfehler wird ber ERR_COUNT gezaehlt
	und zurueckgegeben!!
18.04.2009 Gusenbauer
 + Pruefung eingefuehrt welche bei M0.1 die Leseroutine abbricht
   wenn 0 gelesen wird (am sinnvollsten als erste Variable uebergeben)
30.04.2009 Gusenbauer
 + Baustein um REAL erweitert und wird als FLOAT abgelegt, Anfrage von MICHELH

*****************************************************************************/
function S7_VAR_IDs_READ($S7_Instanz_ID,$S7_Path,$S7_VAR_IDs)
{
  CheckCreateCategory($S7_Path);
  $err_count = 0;

LOGFILE("START FUNCTION");

  while($S7_VAR_ID = each($S7_VAR_IDs))
    {
LOGFILE("WHILE START ==> " . $S7_VAR_ID[0]);

 		   //Wenn Variable noch nicht existiert
			if ($S7_VAR_ID[1][0] == 0)
				{
             $VarID = CheckCreateVariable($S7_Path . "/" . $S7_VAR_ID[0],0);  //boolean
				}
			else if ($S7_VAR_ID[1][0] == 7)
				{
             $VarID = CheckCreateVariable($S7_Path . "/" . $S7_VAR_ID[0],2);  //float
				}
			else
				{
             $VarID = CheckCreateVariable($S7_Path . "/" . $S7_VAR_ID[0],1);  //integer
				}

LOGFILE("START INSTANZ AENDERN ==> " . $S7_VAR_ID[0]);

         S7_SetType        ($S7_Instanz_ID,$S7_VAR_ID[1][0]);
         S7_SetArea        ($S7_Instanz_ID,$S7_VAR_ID[1][1]);
         S7_SetAreaAddress ($S7_Instanz_ID,$S7_VAR_ID[1][2]);
         S7_SetAddress     ($S7_Instanz_ID,$S7_VAR_ID[1][3]);
         S7_SetBit         ($S7_Instanz_ID,$S7_VAR_ID[1][4]);

			//Polltimer sicherheitshalber ausschalten
         S7_SetPoller      ($S7_Instanz_ID,0);

LOGFILE("ENDE INSTANZ AENDERN ==> " . $S7_VAR_ID[0]);

LOGFILE("START INSTANZANDERUNG SPEICHERN ==> " . $S7_VAR_ID[0]);

			//Instanzkonfiguration speichern
			IPS_ApplyChanges($S7_Instanz_ID);

LOGFILE("ENDE INSTANZANDERUNG SPEICHERN ==> " . $S7_VAR_ID[0]);

LOGFILE("START READ ==> " . $S7_VAR_ID[0]);

			if (S7_RequestRead($S7_Instanz_ID) == true)
				{
LOGFILE("START LESE NEUE STATUSVARID ==> " . $S7_VAR_ID[0]);

			    $VarStatusID = IPS_GetStatusVariableID($S7_Instanz_ID,"Value");

LOGFILE("ENDE LESE STATUSVARID ==> " . $S7_VAR_ID[0]);

				 //Check ob eine konvertierung stattfinden soll
				 if ($S7_VAR_ID[1][5] == 1)
					 {
                 $S7_READ_VALUE = intval(hexdec(GetValue($VarStatusID)));
					 }
				 else if ($S7_VAR_ID[1][5] == 2)
					 {
                 $S7_READ_VALUE = intval(dechex(GetValue($VarStatusID)));
					 }
				 else
					 {
                 $S7_READ_VALUE = GetValue($VarStatusID);
					 }

LOGFILE("START PRUEFE OB M0.1 ==> " . $S7_VAR_ID[0]);

				//Pruefung ob Variable M0.1 entspricht und wenn hier der Wert 0, dann lesen abbrechen
				//nicht so schoen aber Wirkungsvoll, denn beim Anlauf immer wieder 0 fuer alle Variablen gelesen

				if ($S7_VAR_ID[0] == "M0.1")
					{
					if($S7_READ_VALUE == false)
					  {
                  $err_count++;
  					   echo "FEHLER: M0.1 ist mit 0 gelesen worden --> Abbruch der Leseroutine\r\n";
						return $err_count;
					  }
					}

				//----------------------------------------

LOGFILE("ENDE PRUEFE OB M0.1 ==> " . $S7_VAR_ID[0]);

LOGFILE("START SCHREIBE VARIABLE ==> " . $S7_VAR_ID[0]);

			   //S7_VAR_ID - Wert aktualisieren
			   if ($S7_VAR_ID[1][0] == 0)
				   {
				    if (SetValueBoolean($VarID,$S7_READ_VALUE) == false)
						 {
					     echo "FEHLER: Wert '" . $S7_READ_VALUE . "' konnte mit SetValueBoolean auf die ID: " . $VarID . " zuwegwiesen werden (" . $S7_Path . "/" . $S7_VAR_ID[0] . ")\r\n";
						 }
  				   }
			   else if ($S7_VAR_ID[1][0] == 7)  //REAL
			      {
				    if (SetValueFloat($VarID,$S7_READ_VALUE) == false)
						 {
					     echo "FEHLER: Wert '" . $S7_READ_VALUE . "' konnte mit SetValueFloat auf die ID: " . $VarID . " zuwegwiesen werden (" . $S7_Path . "/" . $S7_VAR_ID[0] . ")\r\n";
                    $err_count++;
						 }
				   }
			   else
			      {
				    if (SetValueInteger($VarID,$S7_READ_VALUE) == false)
						 {
					     echo "FEHLER: Wert '" . $S7_READ_VALUE . "' konnte mit SetValueInteger auf die ID: " . $VarID . " zuwegwiesen werden (" . $S7_Path . "/" . $S7_VAR_ID[0] . ")\r\n";
                    $err_count++;
						 }

				   }


LOGFILE("ENDE VAR SCHREIBEN ==> " . $S7_VAR_ID[0]);


			  }
			else
			  {
			  echo ("WARNING: Fehler beim lesen der S7-Variable: " . $S7_VAR_ID[0] . "\r\n");
			  $err_count++;
			  }

LOGFILE("ENDE WHILE ==> " . $S7_VAR_ID[0]);
LOGFILE("+ + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + ");


    }

   if ($err_count>= 1)
		{
		return $err_count;
		}
	else
		{
		return false;
		}


LOGFILE("ENDE FUNKTION");

}

?>